package blusunrize.immersiveengineering.common.blocks.metal.conveyors;

import blusunrize.immersiveengineering.api.ApiUtils;
import blusunrize.immersiveengineering.api.tool.ConveyorHandler;
import blusunrize.immersiveengineering.api.tool.ConveyorHandler.ConveyorDirection;
import blusunrize.immersiveengineering.api.tool.ConveyorHandler.IConveyorTile;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumFacing.Axis;
import net.minecraft.util.ResourceLocation;

/**
 * @author BluSunrize - 20.08.2016
 */
public class ConveyorDrop extends ConveyorBasic
{
	@Override
	public void handleInsertion(TileEntity tile, EntityItem entity, EnumFacing facing, ConveyorDirection conDir, double distX, double distZ)
	{
		TileEntity inventoryTile = tile.func_145831_w().func_175625_s(tile.func_174877_v().func_177982_a(0, -1, 0));
		boolean contact = Math.abs(facing.func_176740_k() == Axis.Z ? (tile.func_174877_v().func_177952_p() + .5 - entity.field_70161_v) : (tile.func_174877_v().func_177958_n() + .5 - entity.field_70165_t)) < .2;

		if(contact && inventoryTile != null && !(inventoryTile instanceof IConveyorTile))
		{
			if(!tile.func_145831_w().field_72995_K)
			{
				ItemStack stack = entity.func_92059_d();
				if(stack != null)
				{
					ItemStack ret = ApiUtils.insertStackIntoInventory(inventoryTile, stack, EnumFacing.UP);
					if(ret == null)
						entity.func_70106_y();
					else if(ret.field_77994_a < stack.field_77994_a)
						entity.func_92058_a(ret);
				}
			}
		}
		else if(contact && (tile.func_145831_w().func_175623_d(tile.func_174877_v().func_177982_a(0, -1, 0)) || inventoryTile instanceof IConveyorTile))
		{
			entity.field_70159_w = 0;
			entity.field_70179_y = 0;
			entity.func_70107_b(tile.func_174877_v().func_177958_n() + .5, tile.func_174877_v().func_177956_o() - .5, tile.func_174877_v().func_177952_p() + .5);
			if(!(tile.func_145831_w().func_175625_s(tile.func_174877_v().func_177982_a(0, -1, 0)) instanceof IConveyorTile))
				ConveyorHandler.revertMagnetSupression(entity, (IConveyorTile) tile);
		}
		else
			super.handleInsertion(tile,entity,facing,conDir,distX,distZ);
	}

	public static ResourceLocation texture_on = new ResourceLocation("immersiveengineering:blocks/conveyor_dropper");
	public static ResourceLocation texture_off = new ResourceLocation("immersiveengineering:blocks/conveyor_dropper_off");

	@Override
	public ResourceLocation getActiveTexture()
	{
		return texture_on;
	}

	@Override
	public ResourceLocation getInactiveTexture()
	{
		return texture_off;
	}
}
